#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING,
# WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND ONLY TESTED IN A WINDOWS ENVIRONMENT AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
#    Name:	Import_XYZ
#      By:	sdmitch
#   Usage:	Plugins>SDM Tools>Misc Tool>Import_XYZ
#		 Note:	
#			
#    Date:	Jan 2016
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	$sdm_CorG_tools.add_item("Import CSV") { SDM::Import_CSV_File.main }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #

module SDM

	module Import_CSV_File
	
		def self.main
			mod=Sketchup.active_model
			ent=mod.active_entities
			sel=mod.selection
			unless sel.empty? || sel.first.class!=Sketchup::Group
				@csv_dir ||= "c:/users/public/temp/"; @csv_file ||= "group.csv"
				xyz_file=UI.openpanel("File to Import from:", @csv_dir,@csv_file)
				if xyz_file
					org = sel.first.transformation.origin
					xyz_input=File.open(xyz_file)
					mod.start_operation "Import XYZ"
					while !xyz_input.eof?
						xyz = xyz_input.readline
						x,y,z,c= xyz.split(",")
						pt=Geom::Point3d.new(x.to_f,y.to_f,z.to_f)
						tr = Geom::Transformation.new(pt-org)
						cpy = sel.first.copy
						cpy.transform! tr
					end
					xyz_input.close
					mod.commit_operation
				end
			else
				UI.messagebox "Select a Group"
			end
		end
	end
end


